#
#
# Convert Input file from edge list format (source destination weight) 
# to (source destination weight destination weight ... ) 
#
#


import os
import sys
import random

fname = sys.argv[1];
outFnm = sys.argv[2];

dat = {}
read_counter = 0
write_counter = 0

# read section
print("reading ...", fname)
f_read = open(fname, "r")
for line in f_read:
    if line[0] is not '#' and line[0] is not '\n' and line[0] is not ' ' and line[0] is not '\t':
        read_counter = read_counter + 1
                
        src = int(line.split()[0])
        dst = int(line.split()[1])
        w = round(random.random(), 6)
		
        if src in dat:
            dat[src].append(dst)
            dat[src].append(w)
        else: 
            dat[src] = [dst, w]
f_read.close()

# write section
print("writing ...", outFnm)
f_write = open(outFnm, 'a+')
key = sorted(dat)
for k in key:
    write_counter = write_counter + (len(dat[k]) // 2)

    f_write.write("%s " % str(k))
    #print(dat[k], len(dat[k]), dat[k][0], dat[k][1])
    i = 0
    while i < len(dat[k]):
        f_write.write("%s %0.6f " % (str(dat[k][i]), float(dat[k][i+1])))
        #print(dat[k][i], dat[k][i+1])
        i = i + 2
    f_write.write("\n")
f_write.close()

if read_counter == write_counter: # (weak) input/output validation
    print("...PASSED...", outFnm)
else:
    print("...FAILED...", outFnm, read_counter, write_counter)

##
##
##
##

